; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Torrent Adder"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "Igor N"
!define PRODUCT_WEB_SITE "http://www.palmoid.com"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\TorrentAdder.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

!include nsDialogs.nsh
!include LogicLib.nsh
!include StrFunc.nsh
${StrTok}
; MUI 1.67 compatible ------
!include "MUI.nsh"


; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "license.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
Page custom nsDialogsPage nsDialogsPageLeave
; Finish page
!define MUI_FINISHPAGE_RUN_TEXT "Check re-trackers availability"
!define MUI_FINISHPAGE_RUN "$INSTDIR\TrackerChecker.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Russian"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "tadd_setup.exe"
InstallDir "$PROGRAMFILES\Torrent Patcher"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

var newSetIni
var newTraIni

Section "MainSection" SEC01
    SetOutPath "$INSTDIR"
    SetOverwrite ifnewer
    File "..\Release\TorrentAdder.exe"
    File "..\TrackerChecker\Release\TrackerChecker.exe"
    File "..\Doc\readme.txt"

    ;   settings.ini
    StrCpy $newSetIni 0
    IfFileExists "$INSTDIR\Settings.ini" have_set_ini
    goto replace_set_ini
have_set_ini:
    MessageBox MB_YESNO "You already have Settings.ini file. Do you want to replace it?" IDYES replace_set_ini IDNO set_ini_all
replace_set_ini:
    SetOverwrite on
    File "..\Install\Settings.ini"
    StrCpy $newSetIni 1
set_ini_all:


    ;   trackerssimple.ini
    StrCpy $newTraIni 0
    IfFileExists "$INSTDIR\trackerssimple.ini" have_tra_ini
    goto replace_tra_ini
have_tra_ini:
    MessageBox MB_YESNO "You already have trackerssimple.ini file. Do you want to replace it?" IDYES replace_tra_ini IDNO tra_ini_all
replace_tra_ini:
    SetOverwrite on
    File "..\Install\Settings.ini"
    StrCpy $newTraIni 1
tra_ini_all:


    SetOverwrite off
    
    
    File "..\Install\trackerssimple.ini"
    WriteRegStr HKCR ".torrent" "" "TorrentAdder"
    WriteRegStr HKCR "TorrentAdder" "" "Torrent patcher program"
    WriteRegStr HKCR "TorrentAdder\shell" "" "open"
    WriteRegStr HKCR "TorrentAdder\shell\open\command" "" "$\"$INSTDIR\TorrentAdder.exe$\" $\"%1$\""
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\TorrentAdder.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\TorrentAdder.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "  $(^Name)   ."
FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "   ,    $(^Name)    ?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\readme.txt"
  Delete "$INSTDIR\TorrentAdder.exe"
  Delete "$INSTDIR\TrackerChecker.exe"
  Delete "$INSTDIR\Settings.ini"
  Delete "$INSTDIR\trackerssimple.ini"

  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  DeleteRegKey HKCR "TorrentAdder"
  SetAutoClose true
SectionEnd

Var Dialog
Var Label
;Var Text
Var cityList
Var providerList
Var torrentPath
Var torrentButton

Var cityNum
Var curCity
Var curCityStr
Var curProvider

Function nsProviderSelect
    SendMessage $providerList ${LB_GETCURSEL} 0 0 $0
    IntOp $curProvider $0 + 1
FunctionEnd

Function nsCitySelect
    SendMessage $cityList ${LB_GETCURSEL} 0 0 $0
;    MessageBox MB_OK $5
    IntOp $curCity $0 + 1
    ReadINIStr $curCityStr $INSTDIR\trackerssimple.ini "" $curCity
	ReadINIStr $0 $INSTDIR\trackerssimple.ini " $curCityStr" ""
    
    ${While} 1 = 1
        SendMessage $providerList ${LB_GETCOUNT} 0 0 $4
        ${If} $4 <= 0
            ${Break}
        ${EndIf}
        SendMessage $providerList ${LB_DELETESTRING} 0 0
    ${EndWhile}

	${For} $2 1 $0
        ReadINIStr $1 $INSTDIR\trackerssimple.ini " $curCityStr" $2
        SendMessage $providerList ${LB_ADDSTRING} 0 "STR:$1"
	${Next}
FunctionEnd

Function nsButtonSelect
    ${NSD_GetText} $torrentPath $0
    nsDialogs::SelectFileDialog open $0 "Executable files | *.exe"
    Pop $0
    StrCmp $0 "" CancelFile
    ${NSD_SetText} $torrentPath $0
CancelFile:
FunctionEnd

Function nsDialogsPage
;    NSISdl::download http://re-tracker.ru/trackerssimple.ini $INSTDIR\trackerssimple.ini
 ;   Pop $0
  ;  MessageBox MB_OK $0
    ;StrCmp $0 success success
    ${If} $newSetIni == 0
          Abort
    ${EndIf}

    StrCpy $curCity -1
    StrCpy $curProvider -1
	nsDialogs::Create 1018
	Pop $Dialog

	${If} $Dialog == error
		Abort
	${EndIf}
	${NSD_CreateLabel} 0 0 100% 12u "Enter your city and provider"
	Pop $Label
	
	${NSD_CreateListBox} 0 13u 50% -45u "City"
	Pop $cityList
	${NSD_CreateListBox} 50% 13u 50% -45u "Provider"
	Pop $providerList
	${NSD_CreateText} 0 -17u 50% 13u ""
	Pop $torrentPath
	${NSD_CreateButton} 51% -17u 13u 13u "..."
	Pop $torrentButton
	${NSD_CreateLabel} 0 -27u 50% -13u "Torrent Program"
    Pop $0


	ReadINIStr $0 $INSTDIR\settings.ini "Settings" "LaunchPath"
	${NSD_SetText} $torrentPath $0
	
	ReadINIStr $cityNum $INSTDIR\trackerssimple.ini "" ""
	${For} $0 1 $cityNum
        ReadINIStr $1 $INSTDIR\trackerssimple.ini "" $0
        SendMessage $cityList ${LB_ADDSTRING} 0 "STR:$1"
	${Next}

	ReadINIStr $0 $INSTDIR\settings.ini "Settings" "TrackerIniIndex"
	${StrTok} $1 $0 " " 0 1
	IntOp $1 $1 + 0
    IntOp $curCity $1 + 1
    
	${StrTok} $7 $0 " " 1 1
	IntOp $7 $7 + 0
    IntOp $curProvider $7 + 1
    
	SendMessage $cityList ${LB_SETCURSEL} $1 0
	Call nsCitySelect
	SendMessage $providerList ${LB_SETCURSEL} $7 0

	
	${NSD_OnChange} $cityList nsCitySelect
	${NSD_OnChange} $providerList nsProviderSelect
	${NSD_OnClick} $torrentButton nsButtonSelect

	nsDialogs::Show
FunctionEnd

Function nsDialogsPageLeave
    IntOp $0 $curCity - 1
    IntOp $1 $curProvider - 1
    WriteINIStr $INSTDIR\Settings.ini "Settings" "TrackerIniIndex" "$0 $1"
    WriteINIStr $INSTDIR\Settings.ini "Settings" "TrackersFile" "$INSTDIR\trackerssimple.ini"
    ${NSD_GetText} $torrentPath $0
    WriteINIStr $INSTDIR\Settings.ini "Settings" "LaunchPath" "$0"
FunctionEnd
